diff --git a/src/odbc/unittests/rownumber.c b/src/odbc/unittests/rownumber.c
index 83fd65c..0ccae96 100644
--- a/src/odbc/unittests/rownumber.c
+++ b/src/odbc/unittests/rownumber.c
@@ -7,7 +7,7 @@
  * TODO make it work and add to Makefile.am
  */
 
-static char software_version[] = "$Id: rownumber.c,v 1.4 2008/11/04 10:59:02 freddy77 Exp $";
+static char software_version[] = "$Id: rownumber.c,v 1.5 2008/11/04 14:46:18 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static void
@@ -70,11 +70,11 @@ main(int argc, char *argv[])
 
 	Connect();
 
-	Command(Statement, "create table #tmp1 (i int)");
-	Command(Statement, "create table #tmp2 (i int)");
-	Command(Statement, "insert into #tmp1 values(1)");
-	Command(Statement, "insert into #tmp1 values(2)");
-	Command(Statement, "insert into #tmp1 values(5)");
+	Command("create table #tmp1 (i int)");
+	Command("create table #tmp2 (i int)");
+	Command("insert into #tmp1 values(1)");
+	Command("insert into #tmp1 values(2)");
+	Command("insert into #tmp1 values(5)");
 
 	DoTest();
 
diff --git a/src/odbc/unittests/rowset.c b/src/odbc/unittests/rowset.c
index 9e79bbd..215fbe0 100644
--- a/src/odbc/unittests/rowset.c
+++ b/src/odbc/unittests/rowset.c
@@ -1,6 +1,6 @@
 #include "common.h"
 
-static char software_version[] = "$Id: rowset.c,v 1.4 2008/11/04 10:59:02 freddy77 Exp $";
+static char software_version[] = "$Id: rowset.c,v 1.5 2008/11/04 14:46:18 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static char odbc_err[256];
@@ -24,7 +24,7 @@ test_err(int n)
 		fprintf(stderr, "Unexpected sql state returned\n");
 		Disconnect();
 		exit(1);
-        }
+	}
 }
 
 int
@@ -63,7 +63,7 @@ main(int argc, char *argv[])
 	CHKSetStmtAttr(SQL_ROWSET_SIZE, (SQLPOINTER) int2ptr(1), 0, "S");
 
 	/* now check that SQLExtendedFetch works as expected */
-	Command(Statement, "CREATE TABLE #rowset(n INTEGER, c VARCHAR(20))");
+	Command("CREATE TABLE #rowset(n INTEGER, c VARCHAR(20))");
 	for (i = 0; i < 10; ++i) {
 		char s[10];
 		char sql[128];
@@ -71,7 +71,7 @@ main(int argc, char *argv[])
 		memset(s, 'a' + i, 9);
 		s[9] = 0;
 		sprintf(sql, "INSERT INTO #rowset(n,c) VALUES(%d,'%s')", i+1, s);
-		Command(Statement, sql);
+		Command(sql);
 	}
 
 	ResetStatement();
diff --git a/src/odbc/unittests/rpc.c b/src/odbc/unittests/rpc.c
index 7027df1..405a0ca 100644
--- a/src/odbc/unittests/rpc.c
+++ b/src/odbc/unittests/rpc.c
@@ -6,7 +6,7 @@
 #include "common.h"
 #include <assert.h>
 
-static char software_version[] = "$Id: rpc.c,v 1.11 2008/11/04 10:59:02 freddy77 Exp $";
+static char software_version[] = "$Id: rpc.c,v 1.12 2008/11/04 14:46:18 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static const char procedure_sql[] = 
@@ -32,7 +32,7 @@ static const char procedure_sql[] =
 		"END \n";
 
 
-static int
+static void
 init_proc(const char *name)
 {
 	static char cmd[4096];
@@ -47,15 +47,8 @@ init_proc(const char *name)
 	printf("Creating procedure %s\n", name);
 	sprintf(cmd, procedure_sql, name);
 
-	if (!SQL_SUCCEEDED(SQLExecDirect(Statement, (SQLCHAR *) cmd, SQL_NTS))) {
-		if (name[0] == '#')
-			printf("Failed to create procedure %s. Wrong permission or not MSSQL.\n", name);
-		else
-			printf("Failed to create procedure %s. Wrong permission.\n", name);
-		CheckReturn();
-		exit(1);
-	}
-	return 0;
+	/* create procedure. Fails if wrong permission or not MSSQL */
+	CHKExecDirect((SQLCHAR *) cmd, SQL_NTS, "SI");
 }
 
 static void
@@ -231,7 +224,7 @@ main(int argc, char *argv[])
 	Test(proc_name);
 	
 	printf("dropping procedure\n");
-	Command(Statement, drop_proc);
+	Command(drop_proc);
 
 	Disconnect();
 
diff --git a/src/odbc/unittests/scroll.c b/src/odbc/unittests/scroll.c
index b5dc2a6..d87e29d 100644
--- a/src/odbc/unittests/scroll.c
+++ b/src/odbc/unittests/scroll.c
@@ -2,7 +2,7 @@
 
 /* Test cursors */
 
-static char software_version[] = "$Id: scroll.c,v 1.8 2008/11/04 10:59:02 freddy77 Exp $";
+static char software_version[] = "$Id: scroll.c,v 1.9 2008/11/04 14:46:18 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 int
@@ -18,7 +18,6 @@ main(int argc, char *argv[])
 	SQLUSMALLINT statuses[ROWS];
 	SQLUSMALLINT i;
 	SQLULEN num_row;
-	SQLRETURN retcode;
 	int i_test;
 
 	typedef struct _test
@@ -48,13 +47,13 @@ main(int argc, char *argv[])
 	CheckCursor();
 
 	/* create test table */
-	Command(Statement, "IF OBJECT_ID('tempdb..#test') IS NOT NULL DROP TABLE #test");
-	Command(Statement, "CREATE TABLE #test(i int, c varchar(6))");
-	Command(Statement, "INSERT INTO #test(i, c) VALUES(1, 'a')");
-	Command(Statement, "INSERT INTO #test(i, c) VALUES(2, 'bb')");
-	Command(Statement, "INSERT INTO #test(i, c) VALUES(3, 'ccc')");
-	Command(Statement, "INSERT INTO #test(i, c) VALUES(4, 'dddd')");
-	Command(Statement, "INSERT INTO #test(i, c) VALUES(5, 'eeeee')");
+	Command("IF OBJECT_ID('tempdb..#test') IS NOT NULL DROP TABLE #test");
+	Command("CREATE TABLE #test(i int, c varchar(6))");
+	Command("INSERT INTO #test(i, c) VALUES(1, 'a')");
+	Command("INSERT INTO #test(i, c) VALUES(2, 'bb')");
+	Command("INSERT INTO #test(i, c) VALUES(3, 'ccc')");
+	Command("INSERT INTO #test(i, c) VALUES(4, 'dddd')");
+	Command("INSERT INTO #test(i, c) VALUES(5, 'eeeee')");
 
 	/* set cursor options */
 	ResetStatement();
@@ -77,8 +76,11 @@ main(int argc, char *argv[])
 
 		printf("Test %d\n", i_test + 1);
 
-		retcode = SQLFetchScroll(Statement, t->type, t->irow);
-		if (retcode == SQL_SUCCESS) {
+		if (t->start == -1) {
+			CHKFetchScroll(t->type, t->irow, "No");
+		} else {
+			CHKFetchScroll(t->type, t->irow, "S");
+
 			if (t->start < 1) {
 				fprintf(stderr, "Rows not expected\n");
 				exit(1);
@@ -107,14 +109,7 @@ main(int argc, char *argv[])
 					exit(1);
 				}
 			}
-			continue;
 		}
-
-		if (retcode == SQL_NO_DATA && t->start == -1)
-			continue;
-
-		fprintf(stderr, "retcode = %d\n", retcode);
-		ODBC_REPORT_ERROR("SQLFetchScroll");
 	}
 
 	ResetStatement();
diff --git a/src/odbc/unittests/t0001.c b/src/odbc/unittests/t0001.c
index 5b4e160..4872809 100644
--- a/src/odbc/unittests/t0001.c
+++ b/src/odbc/unittests/t0001.c
@@ -1,6 +1,6 @@
 #include "common.h"
 
-static char software_version[] = "$Id: t0001.c,v 1.17 2008/11/04 10:59:02 freddy77 Exp $";
+static char software_version[] = "$Id: t0001.c,v 1.18 2008/11/04 14:46:18 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 int
@@ -16,20 +16,20 @@ main(int argc, char *argv[])
 
 	Connect();
 
-	Command(Statement, "if object_id('tempdb..#odbctestdata') is not null drop table #odbctestdata");
+	Command("if object_id('tempdb..#odbctestdata') is not null drop table #odbctestdata");
 
 	command = "create table #odbctestdata ("
 		"col1 varchar(30) not null,"
 		"col2 int not null,"
 		"col3 float not null," "col4 numeric(18,6) not null," "col5 datetime not null," "col6 text not null)";
-	Command(Statement, command);
+	Command(command);
 
 	command = "insert #odbctestdata values ("
 		"'ABCDEFGHIJKLMNOP',"
 		"123456," "1234.56," "123456.78," "'Sep 11 2001 10:00AM'," "'just to check returned length...')";
-	Command(Statement, command);
+	Command(command);
 
-	Command(Statement, "select * from #odbctestdata");
+	Command("select * from #odbctestdata");
 
 	CHKFetch("SI");
 
@@ -45,7 +45,7 @@ main(int argc, char *argv[])
 
 	CHKCloseCursor("SI");
 
-	Command(Statement, "drop table #odbctestdata");
+	Command("drop table #odbctestdata");
 
 	Disconnect();
 
diff --git a/src/odbc/unittests/t0002.c b/src/odbc/unittests/t0002.c
index 120b515..c89628c 100644
--- a/src/odbc/unittests/t0002.c
+++ b/src/odbc/unittests/t0002.c
@@ -1,8 +1,10 @@
 #include "common.h"
 
-static char software_version[] = "$Id: t0002.c,v 1.15 2008/11/04 10:59:02 freddy77 Exp $";
+static char software_version[] = "$Id: t0002.c,v 1.16 2008/11/04 14:46:18 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
+#define SWAP_STMT(b) do { SQLHSTMT xyz = Statement; Statement = b; b = xyz; } while(0)
+
 int
 main(int argc, char *argv[])
 {
@@ -10,10 +12,10 @@ main(int argc, char *argv[])
 
 	Connect();
 
-	Command(Statement, "if object_id('tempdb..#odbctestdata') is not null drop table #odbctestdata");
+	Command("if object_id('tempdb..#odbctestdata') is not null drop table #odbctestdata");
 
-	Command(Statement, "create table #odbctestdata (i int)");
-	Command(Statement, "insert #odbctestdata values (123)");
+	Command("create table #odbctestdata (i int)");
+	Command("insert #odbctestdata values (123)");
 
 	/*
 	 * now we allocate another statement, select, get all results
@@ -24,13 +26,15 @@ main(int argc, char *argv[])
 	Statement = SQL_NULL_HSTMT;
 	CHKAllocStmt(&Statement, "S");
 
-	Command(Statement, "select * from #odbctestdata where 0=1");
+	Command("select * from #odbctestdata where 0=1");
 
 	CHKFetch("No");
 
 	CHKCloseCursor("SI");
 
-	Command(old_Statement, "select * from #odbctestdata");
+	SWAP_STMT(old_Statement);
+	Command("select * from #odbctestdata");
+	SWAP_STMT(old_Statement);
 
 	/* drop first statement .. data should not disappear */
 	CHKFreeStmt(SQL_DROP, "S");
@@ -42,7 +46,7 @@ main(int argc, char *argv[])
 
 	CHKCloseCursor("SI");
 
-	Command(Statement, "drop table #odbctestdata");
+	Command("drop table #odbctestdata");
 
 	Disconnect();
 
diff --git a/src/odbc/unittests/t0003.c b/src/odbc/unittests/t0003.c
index 8c5e115..2a0e9f5 100644
--- a/src/odbc/unittests/t0003.c
+++ b/src/odbc/unittests/t0003.c
@@ -2,17 +2,17 @@
 
 /* Test for SQLMoreResults */
 
-static char software_version[] = "$Id: t0003.c,v 1.18 2008/11/04 10:59:02 freddy77 Exp $";
+static char software_version[] = "$Id: t0003.c,v 1.19 2008/11/04 14:46:18 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static void
 DoTest(int prepared)
 {
-	Command(Statement, "create table #odbctestdata (i int)");
+	Command("create table #odbctestdata (i int)");
 
 	/* test that 2 empty result set are returned correctly */
 	if (!prepared) {
-		Command(Statement, "select * from #odbctestdata select * from #odbctestdata");
+		Command("select * from #odbctestdata select * from #odbctestdata");
 	} else {
 		CHKPrepare((SQLCHAR *)"select * from #odbctestdata select * from #odbctestdata", SQL_NTS, "S");
 		CHKExecute("S");
@@ -28,9 +28,9 @@ DoTest(int prepared)
 	CHKMoreResults("No");
 
 	/* test that skipping a no empty result go to other result set */
-	Command(Statement, "insert into #odbctestdata values(123)");
+	Command("insert into #odbctestdata values(123)");
 	if (!prepared) {
-		Command(Statement, "select * from #odbctestdata select * from #odbctestdata");
+		Command("select * from #odbctestdata select * from #odbctestdata");
 	} else {
 		CHKPrepare((SQLCHAR *)"select * from #odbctestdata select * from #odbctestdata", SQL_NTS, "S");
 		CHKExecute("S");
@@ -45,7 +45,7 @@ DoTest(int prepared)
 
 	CHKMoreResults("No");
 
-	Command(Statement, "drop table #odbctestdata");
+	Command("drop table #odbctestdata");
 }
 
 int
diff --git a/src/odbc/unittests/test64.c b/src/odbc/unittests/test64.c
index 9a42ab7..6a99d5e 100644
--- a/src/odbc/unittests/test64.c
+++ b/src/odbc/unittests/test64.c
@@ -1,7 +1,7 @@
 /* test win64 consistency */
 #include "common.h"
 
-static char software_version[] = "$Id: test64.c,v 1.6 2008/11/04 10:59:02 freddy77 Exp $";
+static char software_version[] = "$Id: test64.c,v 1.7 2008/11/04 14:46:18 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 /*
@@ -17,10 +17,10 @@ check_ipd_params(void)
 	SQLHDESC desc;
 	SQLINTEGER ind;
 
-	CHK(SQLGetStmtAttr,(Statement, SQL_ATTR_PARAMS_PROCESSED_PTR, &ptr, sizeof(ptr), NULL));
+	CHKGetStmtAttr(SQL_ATTR_PARAMS_PROCESSED_PTR, &ptr, sizeof(ptr), NULL, "S");
 
 	/* get IPD */
-	CHK(SQLGetStmtAttr, (Statement, SQL_ATTR_IMP_PARAM_DESC, &desc, sizeof(desc), &ind));
+	CHKGetStmtAttr(SQL_ATTR_IMP_PARAM_DESC, &desc, sizeof(desc), &ind, "S");
 
 	CHK(SQLGetDescField, (desc, 0, SQL_DESC_ROWS_PROCESSED_PTR, &ptr2, sizeof(ptr2), &ind));
 
@@ -43,7 +43,7 @@ set_ipd_params2(SQLULEN *ptr)
 	SQLINTEGER ind;
 
 	/* get IPD */
-	CHK(SQLGetStmtAttr, (Statement, SQL_ATTR_IMP_PARAM_DESC, &desc, sizeof(desc), &ind));
+	CHKGetStmtAttr(SQL_ATTR_IMP_PARAM_DESC, &desc, sizeof(desc), &ind, "S");
 
 	CHK(SQLSetDescField, (desc, 1, SQL_DESC_ROWS_PROCESSED_PTR, ptr, 0));
 }
@@ -51,7 +51,7 @@ set_ipd_params2(SQLULEN *ptr)
 static void
 set_ipd_params3(SQLULEN *ptr)
 {
-	CHK(SQLParamOptions, (Statement, 2, ptr));
+	CHKParamOptions(2, ptr, "S");
 }
 
 typedef void (*rows_set_t)(SQLULEN*);
@@ -103,7 +103,7 @@ test_params(void)
 		CHKSetStmtAttr(SQL_ATTR_PARAMSET_SIZE, (void *) int2ptr(ARRAY_SIZE), 0, "S");
 		CHKBindParameter(1, SQL_PARAM_INPUT, SQL_C_ULONG, SQL_INTEGER, 5, 0, ids, 0, id_lens, "S");
 
-		Command(Statement, "INSERT INTO #tmp1(i) VALUES(?)");
+		Command("INSERT INTO #tmp1(i) VALUES(?)");
 		SQLMoreResults(Statement);
 		for (n = 0; n < ARRAY_SIZE; ++n)
 			SQLMoreResults(Statement);
@@ -134,10 +134,10 @@ check_ird_params(void)
 	SQLHDESC desc;
 	SQLINTEGER ind;
 
-	CHK(SQLGetStmtAttr,(Statement, SQL_ATTR_ROWS_FETCHED_PTR, &ptr, sizeof(ptr), NULL));
+	CHKGetStmtAttr(SQL_ATTR_ROWS_FETCHED_PTR, &ptr, sizeof(ptr), NULL, "S");
 
 	/* get IRD */
-	CHK(SQLGetStmtAttr, (Statement, SQL_ATTR_IMP_ROW_DESC, &desc, sizeof(desc), &ind));
+	CHKGetStmtAttr(SQL_ATTR_IMP_ROW_DESC, &desc, sizeof(desc), &ind, "S");
 
 	CHK(SQLGetDescField, (desc, 0, SQL_DESC_ROWS_PROCESSED_PTR, &ptr2, sizeof(ptr2), &ind));
 
@@ -160,7 +160,7 @@ set_ird_params2(SQLULEN *ptr)
 	SQLINTEGER ind;
 
 	/* get IRD */
-	CHK(SQLGetStmtAttr, (Statement, SQL_ATTR_IMP_ROW_DESC, &desc, sizeof(desc), &ind));
+	CHKGetStmtAttr(SQL_ATTR_IMP_ROW_DESC, &desc, sizeof(desc), &ind, "S");
 
 	CHK(SQLSetDescField, (desc, 1, SQL_DESC_ROWS_PROCESSED_PTR, ptr, 0));
 }
@@ -208,16 +208,16 @@ test_rows(void)
 //		CHKSetStmtAttr(SQL_ATTR_PARAMSET_SIZE, (void *) int2ptr(ARRAY_SIZE), 0, "S");
 //		CHKBindParameter(1, SQL_PARAM_INPUT, SQL_C_ULONG, SQL_INTEGER, 5, 0, ids, 0, id_lens, "S");
 
-		CHK(SQLBindCol, (Statement, 1, SQL_C_ULONG, ids, 0, id_lens));
+		CHKBindCol(1, SQL_C_ULONG, ids, 0, id_lens, "S");
 		if (*p) {
 			CHKSetStmtAttr(SQL_ATTR_ROW_ARRAY_SIZE, (void *) int2ptr(ARRAY_SIZE), 0, "S");
 
-			Command(Statement, "SELECT DISTINCT i FROM #tmp1");
+			Command("SELECT DISTINCT i FROM #tmp1");
 			SQLFetch(Statement);
 		} else {
 			CHKSetStmtAttr(SQL_ROWSET_SIZE, (void *) int2ptr(ARRAY_SIZE), 0, "S");
-			Command(Statement, "SELECT DISTINCT i FROM #tmp1");
-			CHK(SQLExtendedFetch, (Statement, SQL_FETCH_NEXT, 0, &len, NULL));
+			Command("SELECT DISTINCT i FROM #tmp1");
+			CHKExtendedFetch(SQL_FETCH_NEXT, 0, &len, NULL, "S");
 		}
 		SQLMoreResults(Statement);
 
@@ -244,7 +244,7 @@ main(void)
 	use_odbc_version3 = 1;
 	Connect();
 
-	Command(Statement, "create table #tmp1 (i int)");
+	Command("create table #tmp1 (i int)");
 
 	test_params();
 	test_rows();
diff --git a/src/odbc/unittests/testodbc.c b/src/odbc/unittests/testodbc.c
index 3cc3926..6b80e8e 100644
--- a/src/odbc/unittests/testodbc.c
+++ b/src/odbc/unittests/testodbc.c
@@ -10,7 +10,7 @@
 
 #include "common.h"
 
-static char software_version[] = "$Id: testodbc.c,v 1.13 2008/11/04 10:59:02 freddy77 Exp $";
+static char software_version[] = "$Id: testodbc.c,v 1.14 2008/11/04 14:46:18 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #ifdef DEBUG
@@ -37,74 +37,12 @@ typedef struct
 } DbTestEntry;
 
 /*
- * Output ODBC errors.
- */
-static void
-DispODBCErrs(void)
-{
-	SQLCHAR buffer[256];
-	SQLCHAR sqlState[16];
-
-	/* Statement errors */
-	if (Statement) {
-		while (SQLError(Environment, Connection, Statement, sqlState, 0, buffer, sizeof(buffer), 0) == SQL_SUCCESS) {
-			AB_ERROR(("%s, SQLSTATE=%s", buffer, sqlState));
-		}
-	}
-
-	/* Connection errors */
-	while (SQLError(Environment, Connection, SQL_NULL_HSTMT, sqlState, 0, buffer, sizeof(buffer), 0) == SQL_SUCCESS) {
-		AB_ERROR(("%s, SQLSTATE=%s", buffer, sqlState));
-	}
-
-	/* Environmental errors */
-	while (SQLError(Environment, SQL_NULL_HDBC, SQL_NULL_HSTMT, sqlState, 0, buffer, sizeof(buffer), 0) == SQL_SUCCESS) {
-		AB_ERROR(("%s, SQLSTATE=%s", buffer, sqlState));
-	}
-}
-
-/*
- * Output ODBC diagnostics. Only used for 'raw' ODBC tests.
- */
-static void
-DispODBCDiags(void)
-{
-	SQLSMALLINT recNumber;
-	SQLCHAR sqlState[10];
-	SQLINTEGER nativeError = -99;
-	SQLCHAR messageText[500];
-	SQLSMALLINT bufferLength = 500;
-	SQLSMALLINT textLength = -99;
-	SQLRETURN status;
-
-	recNumber = 1;
-
-	AB_FUNCT(("DispODBCDiags (in)"));
-
-	do {
-		status = SQLGetDiagRec(SQL_HANDLE_STMT, Statement, recNumber,
-				       sqlState, &nativeError, messageText, bufferLength, &textLength);
-		if (status != SQL_SUCCESS) {
-			/* No data mean normal end of iteration. Anything else is error. */
-			if (status != SQL_NO_DATA) {
-				AB_ERROR(("SQLGetDiagRec status is %d", status));
-			}
-			break;
-		}
-		printf("DIAG #%d, sqlState=%s, nativeError=%d, message=%s\n", recNumber, sqlState, (int) nativeError, messageText);
-		recNumber++;
-	} while (status == SQL_SUCCESS);
-
-	AB_FUNCT(("DispODBCDiags (out)"));
-}
-
-/*
  * Test that makes a parameterized ODBC query using SQLPrepare and SQLExecute
  */
 static int
 TestRawODBCPreparedQuery(void)
 {
-	SQLCHAR queryString[200];
+	SQLCHAR *queryString;
 	SQLLEN lenOrInd = 0;
 	SQLSMALLINT supplierId = 4;
 	int count;
@@ -117,7 +55,7 @@ TestRawODBCPreparedQuery(void)
 
 	/* MAKE QUERY */
 
-	Command(Statement, "CREATE TABLE #Products ("
+	Command("CREATE TABLE #Products ("
 		"ProductID int NOT NULL ,"
 		"ProductName varchar (40) ,"
 		"SupplierID int NULL ,"
@@ -136,7 +74,7 @@ TestRawODBCPreparedQuery(void)
 		"INSERT INTO #Products(ProductID,ProductName,SupplierID,CategoryID,QuantityPerUnit,UnitPrice,UnitsInStock,UnitsOnOrder,ReorderLevel,Discontinued) VALUES(12,'Queso Manchego La Pastora',5,4,'10 - 500 g pkgs.',38.00,86,0,0,0)");
 	while (SQLMoreResults(Statement) == SQL_SUCCESS);
 
-	strcpy((char *) queryString, "SELECT * FROM #Products WHERE SupplierID = ?");
+	queryString = (SQLCHAR *) "SELECT * FROM #Products WHERE SupplierID = ?";
 
 	CHKBindParameter(1, SQL_PARAM_INPUT, SQL_C_SSHORT, SQL_INTEGER, 0, 0, &supplierId, 0, &lenOrInd, "S");
 
@@ -175,7 +113,6 @@ TestRawODBCPreparedQuery(void)
 static int
 TestRawODBCDirectQuery(void)
 {
-	SQLCHAR queryString[200];
 	SQLLEN lenOrInd = 0;
 	SQLSMALLINT supplierId = 1;
 	int count;
@@ -188,7 +125,7 @@ TestRawODBCDirectQuery(void)
 
 	/* MAKE QUERY */
 
-	Command(Statement, "CREATE TABLE #Products ("
+	Command("CREATE TABLE #Products ("
 		"ProductID int NOT NULL ,"
 		"ProductName varchar (40) ,"
 		"SupplierID int NULL ,"
@@ -207,11 +144,9 @@ TestRawODBCDirectQuery(void)
 		"INSERT INTO #Products(ProductID,ProductName,SupplierID,CategoryID,QuantityPerUnit,UnitPrice,UnitsInStock,UnitsOnOrder,ReorderLevel,Discontinued) VALUES(5,'Chef Anton''s Gumbo Mix',2,2,'36 boxes',21.35,0,0,0,1) ");
 	while (SQLMoreResults(Statement) == SQL_SUCCESS);
 
-	strcpy((char *) queryString, "SELECT * FROM #Products WHERE SupplierID = ?");
-
 	CHKBindParameter(1, SQL_PARAM_INPUT, SQL_C_SSHORT, SQL_INTEGER, 0, 0, &supplierId, 0, &lenOrInd, "S");
 
-	CHKExecDirect(queryString, SQL_NTS, "S");
+	CHKExecDirect((SQLCHAR *) "SELECT * FROM #Products WHERE SupplierID = ?", SQL_NTS, "S");
 
 	count = 0;
 
@@ -247,7 +182,7 @@ TestRawODBCGuid(void)
 {
 	SQLRETURN status;
 
-	SQLCHAR queryString[300];
+	SQLCHAR *queryString;
 	SQLLEN lenOrInd;
 	SQLSMALLINT age;
 	SQLCHAR guid[40];
@@ -267,30 +202,22 @@ TestRawODBCGuid(void)
 
 	AB_PRINT(("Creating #pet table"));
 
-	strcpy((char *) (queryString), "CREATE TABLE #pet (name VARCHAR(20), owner VARCHAR(20), "
-	       "species VARCHAR(20), sex CHAR(1), age INTEGER, " "guid UNIQUEIDENTIFIER DEFAULT NEWID() ); ");
-	status = SQLExecDirect(Statement, queryString, SQL_NTS);
-	if (status != SQL_SUCCESS && status != SQL_NO_DATA) {
-		AB_ERROR(("Create table failed"));
-		goto odbcfail;
-	}
+	queryString = (SQLCHAR *) "CREATE TABLE #pet (name VARCHAR(20), owner VARCHAR(20), "
+	       "species VARCHAR(20), sex CHAR(1), age INTEGER, " "guid UNIQUEIDENTIFIER DEFAULT NEWID() ); ";
+	CHKExecDirect(queryString, SQL_NTS, "SNo");
 
 	CommandWithResult(Statement, "DROP PROC GetGUIDRows");
 
 	AB_PRINT(("Creating stored proc GetGUIDRows"));
 
-	strcpy((char *) (queryString), "CREATE PROCEDURE GetGUIDRows (@guidpar uniqueidentifier) AS \
-                SELECT name, guid FROM #pet WHERE guid = @guidpar");
-	status = SQLExecDirect(Statement, queryString, SQL_NTS);
-	if (status != SQL_SUCCESS && status != SQL_NO_DATA) {
-		AB_ERROR(("Create procedure failed"));
-		goto odbcfail;
-	}
+	queryString = (SQLCHAR *) "CREATE PROCEDURE GetGUIDRows (@guidpar uniqueidentifier) AS \
+                SELECT name, guid FROM #pet WHERE guid = @guidpar";
+	CHKExecDirect(queryString, SQL_NTS, "SNo");
 
 	AB_PRINT(("Insert row 1"));
 
-	strcpy((char *) (queryString), "INSERT INTO #pet( name, owner, species, sex, age ) \
-                         VALUES ( 'Fang', 'Mike', 'dog', 'm', 12 );");
+	queryString = (SQLCHAR *) "INSERT INTO #pet( name, owner, species, sex, age ) \
+                         VALUES ( 'Fang', 'Mike', 'dog', 'm', 12 );";
 	CHKExecDirect(queryString, SQL_NTS, "S");
 
 	AB_PRINT(("Insert row 2"));
@@ -298,9 +225,9 @@ TestRawODBCGuid(void)
 	/*
 	 * Ok - new row with explicit GUID, but parameterised age.
 	 */
-	strcpy((char *) (queryString), "INSERT INTO #pet( name, owner, species, sex, age, guid ) \
+	queryString = (SQLCHAR *) "INSERT INTO #pet( name, owner, species, sex, age, guid ) \
                          VALUES ( 'Splash', 'Dan', 'fish', 'm', ?, \
-                         '12345678-1234-1234-1234-123456789012' );");
+                         '12345678-1234-1234-1234-123456789012' );";
 
 	lenOrInd = 0;
 	age = 3;
@@ -313,8 +240,8 @@ TestRawODBCGuid(void)
 	/*
 	 * Ok - new row with parameterised GUID.
 	 */
-	strcpy((char *) (queryString), "INSERT INTO #pet( name, owner, species, sex, age, guid ) \
-                         VALUES ( 'Woof', 'Tom', 'cat', 'f', 2, ? );");
+	queryString = (SQLCHAR *) "INSERT INTO #pet( name, owner, species, sex, age, guid ) \
+                         VALUES ( 'Woof', 'Tom', 'cat', 'f', 2, ? );";
 
 	lenOrInd = SQL_NTS;
 	strcpy((char *) (guid), "87654321-4321-4321-4321-123456789abc");
@@ -326,8 +253,8 @@ TestRawODBCGuid(void)
 	/*
 	 * Ok - new row with parameterised GUID.
 	 */
-	strcpy((char *) (queryString), "INSERT INTO #pet( name, owner, species, sex, age, guid ) \
-                         VALUES ( 'Spike', 'Diane', 'pig', 'f', 4, ? );");
+	queryString = (SQLCHAR *) "INSERT INTO #pet( name, owner, species, sex, age, guid ) \
+                         VALUES ( 'Spike', 'Diane', 'pig', 'f', 4, ? );";
 
 	lenOrInd = SQL_NTS;
 	strcpy((char *) (guid), "1234abcd-abcd-abcd-abcd-123456789abc");
@@ -339,8 +266,8 @@ TestRawODBCGuid(void)
 	/*
 	 * Ok - new row with parameterised GUID.
 	 */
-	strcpy((char *) (queryString), "INSERT INTO #pet( name, owner, species, sex, age, guid ) \
-                         VALUES ( 'Fluffy', 'Sam', 'dragon', 'm', 16, ? );");
+	queryString = (SQLCHAR *) "INSERT INTO #pet( name, owner, species, sex, age, guid ) \
+                         VALUES ( 'Fluffy', 'Sam', 'dragon', 'm', 16, ? );";
 
 	sqlguid.Data1 = 0xaabbccdd;
 	sqlguid.Data2 = 0xeeff;
@@ -368,7 +295,7 @@ TestRawODBCGuid(void)
 	 * Now retrieve rows - especially GUID column values.
 	 */
 	AB_PRINT(("retrieving name and guid"));
-	strcpy((char *) (queryString), "SELECT name, guid FROM #pet");
+	queryString = (SQLCHAR *) "SELECT name, guid FROM #pet";
 	CHKExecDirect(queryString, SQL_NTS, "S");
 	while (SQLFetch(Statement) == SQL_SUCCESS) {
 		count++;
@@ -390,7 +317,7 @@ TestRawODBCGuid(void)
 	 */
 
 	AB_PRINT(("retrieving name and guid again"));
-	strcpy((char *) (queryString), "SELECT name, guid FROM #pet");
+	queryString = (SQLCHAR *) "SELECT name, guid FROM #pet";
 	CHKExecDirect(queryString, SQL_NTS, "S");
 	while (CHKFetch("SNo") == SQL_SUCCESS) {
 		count++;
@@ -416,7 +343,7 @@ TestRawODBCGuid(void)
 	 */
 	AB_PRINT(("retrieving name and guid"));
 
-	strcpy((char *) (queryString), "{call GetGUIDRows(?)}");
+	queryString = (SQLCHAR *) "{call GetGUIDRows(?)}";
 	lenOrInd = SQL_NTS;
 	strcpy((char *) (guid), "87654321-4321-4321-4321-123456789abc");
 
@@ -445,12 +372,6 @@ TestRawODBCGuid(void)
 
 	AB_FUNCT(("TestRawODBCGuid (out): ok"));
 	return TRUE;
-
-      odbcfail:
-	DispODBCErrs();
-	DispODBCDiags();
-	AB_FUNCT(("TestRawODBCGuid (out): error"));
-	return FALSE;
 }
 
 /**
@@ -507,9 +428,7 @@ main(int argc, char *argv[])
 {
 	use_odbc_version3 = 1;
 
-	if (RunTests()) {
+	if (RunTests())
 		return 0;	/* Success */
-	} else {
-		return 1;	/* Error code */
-	}
+	return 1;	/* Error code */
 }
diff --git a/src/odbc/unittests/timeout.c b/src/odbc/unittests/timeout.c
index 5e86031..5a820aa 100644
--- a/src/odbc/unittests/timeout.c
+++ b/src/odbc/unittests/timeout.c
@@ -3,7 +3,7 @@
 
 /* Test timeout of query */
 
-static char software_version[] = "$Id: timeout.c,v 1.9 2008/11/04 10:59:02 freddy77 Exp $";
+static char software_version[] = "$Id: timeout.c,v 1.10 2008/11/04 14:46:18 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static void
@@ -31,13 +31,13 @@ main(int argc, char *argv[])
 
 	/* here we can't use temporary table cause we use two connection */
 	CommandWithResult(Statement, "drop table test_timeout");
-	Command(Statement, "create table test_timeout(n numeric(18,0) primary key, t varchar(30))");
+	Command("create table test_timeout(n numeric(18,0) primary key, t varchar(30))");
 	AutoCommit(SQL_AUTOCOMMIT_OFF);
 
-	Command(Statement, "insert into test_timeout(n, t) values(1, 'initial')");
+	Command("insert into test_timeout(n, t) values(1, 'initial')");
 	EndTransaction(SQL_COMMIT);
 
-	Command(Statement, "update test_timeout set t = 'second' where n = 1");
+	Command("update test_timeout set t = 'second' where n = 1");
 
 	/* save this connection and do another */
 	env = Environment;
@@ -76,7 +76,7 @@ main(int argc, char *argv[])
 
 	/* Sybase do not accept DROP TABLE during a transaction */
 	AutoCommit(SQL_AUTOCOMMIT_ON);
-	Command(Statement, "drop table test_timeout");
+	Command("drop table test_timeout");
 
 	Disconnect();
 
diff --git a/src/odbc/unittests/timeout2.c b/src/odbc/unittests/timeout2.c
index 0d5802d..a5f8f26 100644
--- a/src/odbc/unittests/timeout2.c
+++ b/src/odbc/unittests/timeout2.c
@@ -14,7 +14,7 @@
  * Test from Ou Liu, cf "Query Time Out", 2006-08-08
  */
 
-static char software_version[] = "$Id: timeout2.c,v 1.6 2008/11/04 10:59:02 freddy77 Exp $";
+static char software_version[] = "$Id: timeout2.c,v 1.7 2008/11/04 14:46:18 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #if defined(__MINGW32__) || defined(WIN32)
@@ -28,8 +28,8 @@ main(int argc, char *argv[])
 
 	Connect();
 
-	Command(Statement, "create table #timeout(i int)");
-	Command(Statement, "insert into #timeout values(1)");
+	Command("create table #timeout(i int)");
+	Command("insert into #timeout values(1)");
 
 	for (i = 0; i < 2; ++i) {
 
diff --git a/src/odbc/unittests/transaction.c b/src/odbc/unittests/transaction.c
index a7408a9..d90a685 100644
--- a/src/odbc/unittests/transaction.c
+++ b/src/odbc/unittests/transaction.c
@@ -1,6 +1,6 @@
 #include "common.h"
 
-static char software_version[] = "$Id: transaction.c,v 1.14 2008/11/04 10:59:02 freddy77 Exp $";
+static char software_version[] = "$Id: transaction.c,v 1.15 2008/11/04 14:46:18 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static int
@@ -8,7 +8,7 @@ Test(int discard_test)
 {
 	SQLINTEGER out_buf;
 	SQLLEN out_len;
-	int result = 0;
+	SQLRETURN RetCode;
 	SQLLEN rows;
 	int retcode = 0;
 	char buf[512];
@@ -27,18 +27,18 @@ Test(int discard_test)
 	/* create stored proc */
 	CommandWithResult(Statement, "DROP PROCEDURE testinsert");
 
-	Command(Statement, createProcedure);
+	Command(createProcedure);
 
 	/* create stored proc that generates an error */
 	CommandWithResult(Statement, "DROP PROCEDURE testerror");
 
-	Command(Statement, createErrorProcedure);
+	Command(createErrorProcedure);
 
 	/* Start transaction */
 	CHKSetConnectAttr(SQL_ATTR_AUTOCOMMIT, (void *) SQL_AUTOCOMMIT_OFF, 0, "S");
 
 	/* Insert a value */
-	Command(Statement, "EXEC testinsert 1");
+	Command("EXEC testinsert 1");
 
 	/* we should be able to read row count */
 	CHKRowCount(&rows, "S");
@@ -52,7 +52,7 @@ Test(int discard_test)
 	CHKSetConnectAttr(SQL_ATTR_AUTOCOMMIT, (void *) SQL_AUTOCOMMIT_OFF, 0, "S");
 
 	/* Insert another value */
-	Command(Statement, "EXEC testinsert 2");
+	Command("EXEC testinsert 2");
 
 	/* Roll back transaction */
 	CHKEndTran(SQL_HANDLE_DBC, Connection, SQL_ROLLBACK, "S");
@@ -62,10 +62,10 @@ Test(int discard_test)
 	CHKSetConnectAttr(SQL_ATTR_AUTOCOMMIT, (void *) SQL_AUTOCOMMIT_ON, 0, "S");
 
 	/* generate an error */
-	Command(Statement, "EXEC testerror");
+	Command("EXEC testerror");
 	CHKBindCol(1, SQL_C_SLONG, &out_buf, sizeof(out_buf), &out_len, "S");
 
-	while ((result = SQLFetch(Statement)) == SQL_SUCCESS) {
+	while (CHKFetch("SNo") == SQL_SUCCESS) {
 		printf("\t%ld\n", (long int) out_buf);
 		if (out_buf != 1) {
 			fprintf(stderr, "error: expected to select 1 got %ld\n", (long int) out_buf);
@@ -74,35 +74,12 @@ Test(int discard_test)
 		}
 	}
 
-	if (result != SQL_NO_DATA) {
-		ODBC_REPORT_ERROR("error: SQLFetch: testerror");
-		goto cleanup;
-	}
-
-	result = SQLMoreResults(Statement);
-	printf("SQLMoreResults returned %d\n", result);
-
-	if (result != SQL_ERROR) {
-		fprintf(stderr, "SQLMoreResults should return error\n");
-		retcode = 1;
-		goto cleanup;
-	}
+	CHKMoreResults("E");
 
-	result = SQLGetDiagRec(SQL_HANDLE_STMT, Statement, 1, sqlstate, NULL, (SQLCHAR *)buf, sizeof(buf), NULL);
-	if (result != SQL_SUCCESS && result != SQL_SUCCESS_WITH_INFO) {
-		fprintf(stderr, "Error not set (line %d)\n", __LINE__);
-		retcode = 1;
-		goto cleanup;
-	}
+	CHKGetDiagRec(SQL_HANDLE_STMT, Statement, 1, sqlstate, NULL, (SQLCHAR *)buf, sizeof(buf), NULL, "SI");
 	printf("err=%s\n", buf);
 
-	result = SQLMoreResults(Statement);
-	printf("SQLMoreResults returned %d\n", result);
-	if (result != SQL_NO_DATA) {
-		fprintf(stderr, "SQLMoreResults should return error");
-		retcode = 1;
-		goto cleanup;
-	}
+	CHKMoreResults("No");
 
       cleanup:
 	/* drop table */
@@ -121,7 +98,7 @@ main(int argc, char *argv[])
 
 	/* create table */
 	CommandWithResult(Statement, "DROP TABLE TestTransaction");
-	Command(Statement, "CREATE TABLE TestTransaction ( value INT )");
+	Command("CREATE TABLE TestTransaction ( value INT )");
 
 	if (!retcode)
 		retcode = Test(1);
